-----------------SIGNOS VITALES-----------------------------
CREATE OR REPLACE PROCEDURE ADD_SIG_VIT_PROCE 
(ALTURA_SIV in FLOAT,FRECUENCIA_CARDIACA_SIV IN NUMBER,PESO_SIV in FLOAT,PRESION_ARTERIAL_SIV in VARCHAR2,TEMPERATURA_SIV IN FLOAT,ID_CONSULTA in NUMBER) IS
BEGIN
    INSERT INTO SIGNOSVITALES 
    (ALTURA_SIV,FRECUENCIA_CARDIACA_SIV,PESO_SIV,PRESION_ARTERIAL_SIV,TEMPERATURA_SIV,ID_CONSULTA ) VALUES
    (ALTURA_SIV,FRECUENCIA_CARDIACA_SIV,PESO_SIV,PRESION_ARTERIAL_SIV,TEMPERATURA_SIV,ID_CONSULTA );
    COMMIT;
END;

CREATE SEQUENCE SIG_VIT_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;

create or replace trigger SIG_VIT_TRIGGER  
   before insert on "CLINICA"."SIGNOSVITALES" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_SIGNOS_VITALES" is null then 
         select SIG_VIT_SEQUENCE.nextval into :NEW."ID_SIGNOS_VITALES" from dual; 
      end if; 
   end if; 
end;

create or replace PROCEDURE UDP_SIG_VIT_PROCE 
(IDSIG IN NUMBER, ALT IN FLOAT, FCS IN NUMBER, PESS IN FLOAT, PAS IN VARCHAR2, TES FLOAT, IDCO IN NUMBER) 
IS
ALTS FLOAT;
FCSS NUMBER;
PESSV FLOAT;
PASS VARCHAR2(1024);
TESS FLOAT;
IDCOS NUMBER;
BEGIN
  IF(ALT=NULL)THEN
  SELECT ALTURA_SIV INTO ALTS FROM SIGNOSVITALES WHERE ID_SIGNOS_VITALES = IDSIG;
  ELSE ALTS := ALT; END IF;
  IF(ALT=NULL)THEN
  SELECT FRECUENCIA_CARDIACA_SIV INTO FCSS FROM SIGNOSVITALES WHERE ID_SIGNOS_VITALES = IDSIG;
  ELSE FCSS := FCS; END IF;
  IF(ALT=NULL)THEN
  SELECT PESO_SIV INTO PESSV FROM SIGNOSVITALES WHERE ID_SIGNOS_VITALES = IDSIG;
  ELSE PESSV := PESS; END IF;
  IF(ALT=NULL)THEN
  SELECT PRESION_ARTERIAL_SIV INTO PASS FROM SIGNOSVITALES WHERE ID_SIGNOS_VITALES = IDSIG;
  ELSE PASS := PAS; END IF;
  IF(ALT=NULL)THEN
  SELECT TEMPERATURA_SIV INTO TESS FROM SIGNOSVITALES WHERE ID_SIGNOS_VITALES = IDSIG;
  ELSE TESS := TES; END IF;
  IF(ALT=NULL)THEN
  SELECT ID_CONSULTA INTO IDCOS FROM SIGNOSVITALES WHERE ID_SIGNOS_VITALES = IDSIG;
  ELSE IDCOS := IDCO; END IF;
  UPDATE SIGNOSVITALES
  SET ALTURA_SIV=ALTS,FRECUENCIA_CARDIACA_SIV=FCSS,PESO_SIV=PESSV,PRESION_ARTERIAL_SIV=PASS,TEMPERATURA_SIV=TESS,ID_CONSULTA=IDCOS
  WHERE ID_SIGNOS_VITALES = IDSIG;
  COMMIT;
END;

///////////////////////////////////////////

-------CONSULTA MEDICA--------------------
create or replace PROCEDURE ADD_CON_MED_PROCE 
(ID_CAT IN NUMBER,IDDOCTOR in NUMBER, DESCRIPCION IN VARCHAR2 ,IDEXPEDIENTE in NUMBER) IS
FECHA DATE;
CORRELATIVO NUMBER(10,0) := 0;
MAXFECHA DATE;
BEGIN

    SELECT SYSDATE INTO FECHA FROM DUAL;
    SELECT MAX(FECHA_CON) INTO MAXFECHA FROM CONSULTAMEDICA WHERE ID_CAT_CON = ID_CAT;
    SELECT MAX(CORRELATIVO_CON) INTO CORRELATIVO  FROM CONSULTAMEDICA WHERE  ID_CAT_CON = ID_CAT AND TO_DATE(FECHA_CON, 'DD/MM/YYYY') = TO_DATE(MAXFECHA,'DD/MM/YYYY');

    IF(MAXFECHA = NULL ) THEN
    MAXFECHA := FECHA;
    CORRELATIVO := 0;
    END IF;
    IF(TO_CHAR(MAXFECHA,'DD/MM/YYYY') = TO_CHAR(FECHA, 'DD/MM/YYYY')) THEN
       CORRELATIVO := CORRELATIVO + 1;
    ELSE
        CORRELATIVO := 1;
    END IF;
    INSERT INTO CONSULTAMEDICA
    (CORRELATIVO_CON,FECHA_CON,DESCRIPCION_CON,ID_CAT_CON,ID_DOCTOR,ID_EXPEDIENTE) VALUES
    (CORRELATIVO,    FECHA,    DESCRIPCION,    ID_CAT,    IDDOCTOR, IDEXPEDIENTE);
    COMMIT;
END;

CREATE SEQUENCE CON_MED_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;
 
 create or replace trigger CON_MED_TRIGGER  
   before insert on "CLINICA"."CONSULTAMEDICA" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_CONSULTA" is null then 
         select CON_MED_SEQUENCE.nextval into :NEW."ID_CONSULTA" from dual; 
      end if; 
   end if; 
end;

create or replace PROCEDURE UDP_CON_MED_PROCE 
(IDCON IN NUMBER, DES IN VARCHAR2, IDDO IN NUMBER) 
IS
DESCO VARCHAR2(1024);
IDDOC NUMBER;
BEGIN
  IF(DES=NULL)THEN
  SELECT DESCRIPCION_CON INTO DESCO FROM CONSULTAMEDICA WHERE ID_CONSULTA = IDCON;
  ELSE
  DESCO := DES;
  END IF;
  IF(IDDO=NULL)THEN
  SELECT ID_DOCTOR INTO IDDOC FROM CONSULTAMEDICA WHERE ID_CONSULTA = IDCON;
  ELSE
  IDDOC := IDDO;
  END IF;
  UPDATE CONSULTAMEDICA
  SET DESCRIPCION_CON = DESCO, ID_DOCTOR = IDDOC
  WHERE ID_CONSULTA = IDCON;
  COMMIT;
END;

////////////////////////////////////////////////
------------Empleado------------------------------

CREATE OR REPLACE PROCEDURE ADD_EMP_PROCE 
(APELLIDO_EMPLEADO in VARCHAR2,DUI_EMP IN VARCHAR2,EMAIL in VARCHAR2,NOMBRE_EMPLEADO in VARCHAR2,TELEFONO_EMP IN VARCHAR2) IS
BEGIN
    INSERT INTO EMPLEADO 
    (APELLIDO_EMPLEADO, DUI_EMP, EMAIL_EMP,NOMBRE_EMPLEADO,TELEFONO_EMP ) VALUES
    (APELLIDO_EMPLEDO,DUI_EMP,EMAIL_EMP,NOMBRE_EMPLEADO,TELEFONO_EMP );
    COMMIT;
END;

CREATE SEQUENCE EMP_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;

create or replace trigger EMP_TRIGGER  
   before insert on "CLINICA"."EMPLEADO" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_EMPLEADO" is null then 
         select EMP_SEQUENCE.nextval into :NEW."ID_EMPLEADO" from dual; 
      end if; 
   end if; 
end;

create or replace PROCEDURE UPD_EMP_PROCE 
(IDEMP IN NUMBER, APE IN VARCHAR2, DUI IN VARCHAR2, EMIL IN VARCHAR2, NOM IN VARCHAR2, TELE IN VARCHAR2) 
IS
APEE VARCHAR2(1024);
DUIE VARCHAR2(1024);
EMILE VARCHAR2(1024);
TELEE VARCHAR2(1024);
NOME VARCHAR2(1024);
BEGIN
  IF(APE=NULL)THEN
  SELECT APELLIDO_EMPLEADO INTO APEE FROM EMPLEADO WHERE ID_EMPLEADO = IDEMP;
  ELSE
  APEE := APE;
  END IF;
  IF(DUI=NULL)THEN
  SELECT DUI_EMP INTO DUIE FROM EMPLEADO WHERE ID_EMPLEADO = IDEMP;
  ELSE
  DUIE := DUI;
  END IF;
  IF(EMIL=NULL)THEN
  SELECT EMIL_EMP INTO EMILE FROM EMPLEADO WHERE ID_EMPLEADO = IDEMP;
  ELSE
  EMILE := EMIL;
  END IF;
   IF(NOM=NULL)THEN
  SELECT NOMBRE_EMPLEADO INTO NOME FROM EMPLEADO WHERE ID_EMPLEADO = IDEMP;
  ELSE
  NOME := NOM;
  END IF;
  IF(TELE=NULL)THEN
  SELECT TELEFONO_EMP INTO TELEE FROM EMPLEADO WHERE ID_EMPLEADO = IDEMP;
  ELSE
  TELEE := TELE;
  END IF;
  UPDATE EMPLEADO
  SET APELLIDO_EMPLEADO = APEE, NOMBRE_EMPLEADO = NOME, DUI_EMP = DUIE, EMIL_EMP = EMILE, TELEFONO_EMP = TELEE
  WHERE ID_EMPLEADO=IDEMP;
  COMMIT;
END;

//////////////////////////////////////////////////////////////////////
--------------------------Doctor--------------------------------------

CREATE OR REPLACE PROCEDURE ADD_DOC_PROCE 
(ESPECIALIDAD_DOC in VARCHAR2, ID_EMPLEADO in NUMBER) IS
BEGIN
    INSERT INTO DOCTOR 
    (ESPECIALIDAD_DOC, ID_EMPLEADO ) VALUES
    (ESPECIALIDAD_DOC, ID_EMPLEADO );
    COMMIT;
END;

CREATE SEQUENCE DOC_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;

create or replace trigger DOC_TRIGGER  
   before insert on "CLINICA"."DOCTOR" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_DOCTOR" is null then 
         select DOC_SEQUENCE.nextval into :NEW."ID_DOCTOR" from dual; 
      end if; 
   end if; 
end;

create or replace PROCEDURE UDP_DOC_PROCE 
(IDDOC IN NUMBER, ESP IN VARCHAR2, IDEM IN NUMBER) 
IS
ESPD VARCHAR2(1024);
IDEMD NUMBER;
BEGIN
  IF(ESP=NULL)THEN
  SELECT ESPECIALIDAD_DOC INTO ESPD FROM DOCTOR WHERE ID_DOCTOR = IDDOC;
  ELSE
  ESPD := ESP;
  END IF;
  IF(IDEM=NULL)THEN
  SELECT ID_EMPLEADO INTO IDEMD FROM DOCTOR WHERE ID_DOCTOR = IDDOC;
  ELSE
  IDEMD := IDEM;
  END IF;
  UPDATE DOCTOR
  SET ESPECIALIDAD_DOC = ESPD, ID_EMPLEADO = IDEMD
  WHERE ID_DOCTOR=IDDOC;
  COMMIT;
END;

/////////////////////////////////////////////////////////////////////
-------------------SINTOMATOLOGIA---------------------------------

CREATE OR REPLACE PROCEDURE ADD_SIN_PROCE 
(SIT IN VARCHAR2, IDCON IN NUMBER) IS
BEGIN
    INSERT INTO SINTOMATOLOGIA 
    (SINTOMAS,ID_CONSULTA) VALUES
    (SIT,IDCON);
    COMMIT;
END;

CREATE SEQUENCE SIN_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;
 
 CREATE OR REPLACE TRIGGER SIN_TRIGGER  
   BEFORE INSERT ON "CLINICA"."SINTOMATOLOGIA" 
   FOR EACH ROW 
BEGIN  
   IF INSERTING THEN 
      IF :NEW."ID_SINTOMATOLOGIA" IS NULL THEN 
         SELECT SIN_SEQUENCE.NEXTVAL INTO :NEW."ID_SINTOMATOLOGIA" FROM DUAL; 
      END IF; 
   END IF; 
END;

CREATE OR REPLACE PROCEDURE UDP_SIN_PROCE 
(IDS IN NUMBER, SIN IN VARCHAR2, IDC IN NUMBER) 
IS
SINT VARCHAR2(1024);
IDCO NUMBER;
BEGIN
  IF(SIN=NULL)THEN
  SELECT SINTOMAS INTO SINT FROM SINTOMATOLOGIA WHERE ID_SINTOMATOLOGIA = IDS;
  ELSE
  SINT := SIN;
  END IF;
  IF(IDC=NULL)THEN
  SELECT ID_CONSULTA INTO IDCO FROM SINTOMATOLOGIA WHERE ID_SINTOMATOLOGIA = IDS;
  ELSE
  IDCO := IDC;
  END IF;
  UPDATE SINTOMATOLOGIA
  SET SINTOMAS = SIN, ID_CONSULTA = IDCO
  WHERE ID_SINTOMATOLOGIA = IDS;
  COMMIT;
END;

/////////////////////////////////////////////////////////////////////////////////////
---------------------DIAGNOSTICO-------------------------------------------

create or replace PROCEDURE ADD_DIAG_PROCE 
(IDCATDI in NUMBER,IDCO in NUMBER) IS
FECHA DATE;
BEGIN

    SELECT SYSDATE INTO FECHA FROM DUAL;
    INSERT INTO DIAGNOSTICO
    (FECHA_DIAG,ID_CATA_DIAG,ID_CONSULTA) VALUES
    (FECHA, IDCATDI, IDCO);
    COMMIT;
END;

CREATE SEQUENCE DIAG_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;
 
 CREATE OR REPLACE TRIGGER DIAG_TRIGGER  
   BEFORE INSERT ON "CLINICA"."DIAGNOSTICO" 
   FOR EACH ROW 
BEGIN  
   IF INSERTING THEN 
      IF :NEW."ID_DIAGNOSTICO" IS NULL THEN 
         SELECT DIAG_SEQUENCE.NEXTVAL INTO :NEW."ID_DIAGNOSTICO" FROM DUAL; 
      END IF; 
   END IF; 
END;

create or replace PROCEDURE UDP_DIAG_PROCE 
(IDDIAG IN NUMBER, FEC IN DATE, IDCADI in NUMBER,IDCO in NUMBER) 
IS
FECH DATE;
IDCADIG NUMBER;
IDCON NUMBER;
BEGIN
  IF(FEC=NULL)THEN
  SELECT FECHA_DIAG INTO FECH FROM DIAGNOSTICO WHERE ID_DIAGNOSTICO = IDDIAG;
  ELSE
  FECH := FEC;
  END IF;
  IF(IDCADI=NULL)THEN
  SELECT ID_CATA_DIAG INTO IDCADIG FROM DIAGNOSTICO WHERE ID_DIAGNOSTICO = IDDIAG;
  ELSE
  IDCADIG := IDCADI;
  END IF;
  IF(IDCO=NULL)THEN
  SELECT ID_CONSULTA INTO IDCON FROM DIAGNOSTICO WHERE ID_DIAGNOSTICO = IDDIAG;
  ELSE
  IDCON := IDCO;
  END IF;
  UPDATE DIAGNOSTICO
  SET FECHA_DIAG=FECH, ID_CATA_DIAG=IDCADIG, ID_CONSULTA=IDCON
  WHERE ID_DIAGNOSTICO = IDDIAG;
  COMMIT;
END;

alter table diagnostico drop CONSTRAINT 
FKE1XS6M333P2A0XIAMU3FUONQK;
